<template>
  <div>
    <div class="dashboard__header">
      <h1 class="dashboard__title">ویرایش کاربر {{user.username}}</h1>
      <div class="dashboard__actions">
        <Button type="text" color='dark' light round size="sm" @click.native="$router.push('/dashboard/admin/users')">
          <template #icon>
            <BackIcon />
          </template>
        </Button>
      </div>
    </div>
    <div class="dashboard__body">
      <DashboardNavigation class="dashboard__nav" active="users" />
      <Card title="اطلاعات کاربری" class="dashboard__content">
        <div class="avatar" :style="{backgroundImage: `url(${avatar})`}"></div>
        <div class="row">
          <p class="key">نام کاربری</p>
          <p class="value">{{ user.username }}</p>
        </div>
        <div class="row">
          <p class="key">نام و نام خانوادگی</p>
          <p class="value">{{ user.name || 'ثبت نشده' }}</p>
        </div>
        <div class="row">
          <p class="key">ایمیل</p>
          <p class="value">{{ user.email || 'ثبت نشده' }}</p>
        </div>
        <div class="row">
          <p class="key">شماره موبایل</p>
          <p class="value">{{ user.phone || 'ثبت نشده' }}</p>
        </div>
        <EditRoleForm :user="user" @update="onUpdate" class="role" :disabled="user.id === $store.getters['auth/getUser'].id" />
      </Card>
    </div>
  </div>
</template>

<script>
import DashboardNavigation from "@/components/layout/DashboardNavigation";
import CategoriesCard from "@/components/categories-manager/CategoriesCard";
import BackIcon from "@/assets/svgs/back.svg";
import Button from "@/components/base/Button";
import AddIcon from "@/assets/svgs/add.svg";
import Card from "@/components/base/Card";
import ManagingItemRow from "@/components/dashboard/ManagingItemRow";
import EditRoleForm from "@/components/dashboard/EditRoleForm";

export default {
  components: {
    DashboardNavigation,
    CategoriesCard,
    BackIcon,
    Card,
    EditRoleForm,
    ManagingItemRow,
    AddIcon,
    Button
  },
  head() {
    return {
      title: "ویرایش کاربر"
    }
  },
  layout: "dashboard",
  async asyncData(context) {
    let user;
    const id = context.route.params.id;
    const token = context.store.getters['auth/getToken'];
    await context.store.dispatch('auth/fetchUser', { token, id }).then(response => {
      user = response.data.data;
    }).catch(error => {
      console.log(error);
    });
    return {
      user
    };
  },
  methods: {
    onUpdate() {
      this.$router.push('/dashboard/admin/users');
    }
  },
  computed: {
    avatar() {
      return this.user.profilePic ? `${process.env.baseUrl}${this.user.profilePic}` : '/images/profile.png';
    }
  },
  created() {
    console.log(this.user)
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.dashboard__title
  direction rtl

.avatar
  width $dashboard-info-avatar-size
  height $dashboard-info-avatar-size
  border-radius 50%
  margin $md auto
  background-size cover
  background-position center
  overflow hidden

.row
  display flex
  align-items center
  justify-content space-between
  padding $sm $md
  &:not(:last-of-type)
    border-bottom 1px solid rgba($black, .07)
  &:hover
    background-color rgba(black, .03)

.value
  direction ltr

.role
  margin-top $md
</style>